// Sistemas Operativos - Curso 2do Semestre 2011
// Tecnologo en Informatica FIng - CETP
//
// Ejemplo IPC - Servidor
// servidor.c



#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdlib.h>
#include <string.h>
#include "shmem.h"
#include "semaforos.h"
#include "estructuras.h"
#include <iostream>


using namespace std;

bool soyPadre = false;

int cantArch, cantSeg;

int shmid_Arch;

void manejadorSenhales (int signal)
// Manejador de las senhales.
// Aca se debe implementar la accion a realizar cuando se recibe la seal
{
	if (soyPadre)
	{
		if (signal == SIGINT)
		{
			cout << "\33[46m\33[31m[" << getpid() << "]" << " SIGINT CTRL+C recibido\33[00m\n"; 
		}
		if (signal == SIGTERM)
		{
			cout << "\33[46m\33[31m[" << getpid() << "]" << " SIGTERM Terminacion de programa\33[00m\n";
		}
		if (signal == SIGSEGV)
		{
			cout << "\33[46m\33[31m[" << getpid() << "]" << " SIGSEGV violacion de segmento\33[00m\n";
		}
		if (signal == SIGCHLD)
		{
			cout << "\33[46m\33[31m[" << "]" << " SIGCHLD \33[00m\n";
		}
		if (signal == SIGPIPE)
		{
			cout << "\33[46m\33[31m[" << getpid() << "]" << " SIGPIPE \33[00m\n";
		}
		if (signal == SIGKILL)
		{
			cout << "\33[46m\33[31m[" << getpid() << "]" << " SIGKILL \33[00m\n";
		}
		if (signal == SIGSEGV)
		{
			cout << "\33[46m\33[31m[" << getpid() << "]" << " SIGSEGV violacion de segmento\33[00m\n";
		}
		//  Destruir Memoria Compartida
		//  Destruir Semaforos

	}

	exit(1);
}



int main(int argc, char * argv[])
{

//	cout << "Programa llamado con " << argc << " argumentos\n";
//	cout << "Argumento 1: " << argv[0] << endl;
//	cout << "Argumento 2: " << argv[1] << endl;
//	cout << "Argumento 3: " << argv[2] << endl;
//	cout << "Argumento 4: " << argv[3] << endl;

	if (argc < 3)
	{
		cout << "Faltan Parametros\n";
		exit (1);
	}

	cout << "cantArch = " << argv[1] << endl;
	cout << "cantSeg = " << argv[2] << endl;
	
	cantArch = atoi (argv[1]);
	cantSeg = atoi (argv[2]);

	struct sigaction sa;
	memset (&sa, 0, sizeof (sa));
	sa.sa_handler = &manejadorSenhales;

	sigaction(SIGINT, &sa, NULL);
	sigaction(SIGTERM, &sa, NULL);
	sigaction(SIGPIPE, &sa, NULL);
	sigaction(SIGSEGV, &sa, NULL);
	sigaction(SIGKILL, &sa, NULL);
	signal(SIGALRM, SIG_IGN);

	printf("\33[34mSERVIDOR\33[39m: Bienvenido al servidor. Pid %d\n", getpid());
	//int * numero, shmid;//, semid;
/*	
	semid = crear_semaforos (1, ".", 'R');
	if (semid == -1)
	{
		printf("\33[34mSERVIDOR\33[39m: \33[31mError al crear semaforos.\33[39m\n");
		return 0;
	}
	printf("\33[34mSERVIDOR\33[39m: \33[32mSemaforos creados con exito.\33[39m\n");
	

	int error = init(semid, 0, 1);
	if (error == -1)
	{
		printf("\33[34mSERVIDOR\33[39m: \33[31mError al inicializar semaforos.\33[39m\n");
		return 0;
	}
	printf("\33[34mSERVIDOR\33[39m: \33[32mSemaforos inicializados con exito.\33[39m\n");
*/	
	Archivo * Archivos;

	shmid_Arch = CrearMemc (".", 'A', sizeof (Archivo) * cantArch);
	if (shmid_Arch < 0)
	{
		printf ("\33[34mSERVIDOR\33[39m: \33[31mError al pedir memoria.\33[39m\n");
		exit (1);
	}
	else
	{	
		printf ("\33[34mSERVIDOR\33[39m: \33[32mMemoria creada con exito.\33[39m\n");
		Archivos = (Archivo*)DirMemc(shmid_Arch);
	}
	while (true)
	{
		cout << "Servidor de Archivos - Sistemas Operativos 2011\nFIng- CETP\n\n";
		
		int pid_consola = fork ();
		if (pid_consola < 0)
		{
			printf("\33[34mSERVIDOR\33[39m: \33[31mError al bifurcar.\33[39m\n");
			exit (1);
			
		}
		if (pid_consola == 0)
		{

			cout << "Soy el hijo, hago el barrido\n";
			while (true)
			{
				sleep (1);
				// implementar barrido
			}
		}
		if (0 < pid_consola)
		{
			char comando[MAX_COMANDO];
			soyPadre = true;
			cout << "Soy el padre, atiendo la consola\n";
			while (true)
			{
				cout << "> ";
				cin >> comando;
				if (strcmp(comando,"estado") == 0)
				{
					cout << "Archivo\tpid\tTiempo\n----------------------------------------\n";
					//implementar la ejecucion del comando
				}
				else
				{
					cout << "ERROR: Comando Incorrecto.\n";
				}
			}
		}
//		scanf ("%d", numero);
//		printf ("lei el numero %d", (*numero));
	}
}

